
# require "eitil_core/application_controller/permit_model_atts"

require "pry"

module ActionController
  class Parameters

    def permit_model_atts(*models, include: nil, except: nil, arrays: nil, hashes: nil)
      
      models  = models.is_a?(Array)  ? models : [models]
      except  = except.is_a?(Array)  ? except : [except]
      include = include.is_a?(Array) ? include : [include]
      arrays  = arrays.is_a?(Array)  ? arrays : [arrays]
      hashes  = hashes.is_a?(Array)  ? hashes : [hashes]

      columns = models.map do |model|
        model.columns_hash.keys.map &:to_sym
      end.flatten.uniq

      default_reject  = %i( id updated_at created_at )
      given_reject    = except.map { |key| key&.to_sym }
      accepted_values = columns + include - default_reject - given_reject     
      
      arrays = arrays.all?(&:present?) ? arrays.each_with_object({}) { |i,h| h[i] = [] } : nil
      hashes = hashes.all?(&:present?) ? hashes.each_with_object({}) { |i,h| h[i] = {} } : nil

      if arrays.blank? and hashes.blank?
        return self.permit(*accepted_values)

      elsif arrays.blank?
        return self.permit(*accepted_values, **hashes)

      elsif hashes.blank?
        return self.permit(*accepted_values, **arrays)

      else
        return self.permit(*accepted_values, **arrays, **hashes)

      end
    end

  end
end

 