
# require "eitil_core/array/map_strings"

require "eitil_core/hash/transform_string_values"

class Array

  def map_strings!(&block)
    map! do |item|

      if item.class == String
        yield item

      elsif item.class == Hash
        item.transform_string_values!(&block)

      elsif item.class == Array
        item.map_strings!(&block)

      else
        item

      end
    end

    self
  end

  def map_strings(&block)
    deep_dup.map_strings!(&block)
  end

end