
# require "eitil_core/hash/transform_string_values"

require "eitil_core/array/map_strings"

class Hash

  def transform_string_values!(&block)
    transform_values! do |value|

      if value.class == String
        yield value

      elsif value.class == Hash
        value.transform_string_values!(&block)

      elsif value.class == Array
        value.map_strings!(&block)

      else
        value
        
      end
    end
    
    self
  end

  def transform_string_values(&block)
    deep_dup.transform_string_values!(&block)
  end

end
