
# require "eitil_core/mocks/hash"

class Hash

  def self.mock(n=10)
    range = mock_size(n).to_a
    Hash[Array.mock(n) {|m| range[m] }.zip(Array.mock(n))]
  end

  private

  def self.mock_size(n)
    EitilCore::Mock.hash_range_for(n)
  end

end


module EitilCore
  module Mock

   def self.hash_range_for(n)
      range = nil
      i     = 0
      
      until range != nil do
        range = ('a'..'z') if n <= 26
        range = ('a'.."z#{'z'*i}") if n < (26 + (26 ** (i+1) )) && !range
        i += 1
      end
      range
    end

  end
end