
module EitilCore

  class Railtie < Rails::Railtie

      initializer "my_railtie.configure_rails_initialization", options: :after do |app|

        # Dynamic dispatching after initialization of Rails classes.

        # ApplicationRecord
        
        if Object.const_defined?('EitilCore::ApplicationRecord::WhereLike')
          ::ApplicationRecord.send(:extend, EitilCore::ApplicationRecord::WhereLike)
        end

        if Object.const_defined?('EitilCore::ApplicationRecord::FindByLike')
          ::ApplicationRecord.send(:extend, EitilCore::ApplicationRecord::FindByLike)
        end

        if Object.const_defined?('EitilCore::ApplicationRecord::DuckFind')
          ::ApplicationRecord.send(:extend, EitilCore::ApplicationRecord::DuckFind)
        end        

        if Object.const_defined?('EitilCore::ApplicationRecord::AllAssociations')
          ::ApplicationRecord.send(:extend, EitilCore::ApplicationRecord::AllAssociations)
        end

        if Object.const_defined?('EitilCore::ApplicationRecord::ModelAtts')
          ::ApplicationRecord.send(:extend, EitilCore::ApplicationRecord::ModelAtts)
        end

        # ApplicationController

        if Object.const_defined?('EitilCore::ApplicationController::SliceParams')
          ::ActionController::API.send(:include, EitilCore::ApplicationController::SliceParams)
        end        

      end

  end

end