
# require "eitil_core/type_checkers/is_num_or_nan"

require "eitil_store/regex/regex"

class String

  def is_nan?
    self !~ EitilStore::Regex::IsNum
  end

  def is_num?
    !is_nan?
  end

end

# Descending classes which are always numeric

class Numeric

  def is_nan?
    false
  end

  def is_num?
    true
  end

end

# Classes which are never numeric

class NilClass

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class TrueClass

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class FalseClass

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class Hash

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class Array

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class Date

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class DateTime

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class Time

  def is_nan?
    true
  end

  def is_num?
    false
  end

end


class ActiveSupport::TimeWithZone

  def is_nan?
    true
  end

  def is_num?
    false
  end

end

