
# require "eitil_integrate/application_exporter/default_export"

require "eitil_integrate/application_exporter/initialize"

module EitilIntegrate::RubyXL
  class ApplicationExporter

    # The #create_file method is taken out of #export, to be overwritten by 
    # exports variants that want to loop over objects and call it multiple times.
    # => e.g. the context of multiple Environment for a single Organisation

    def export
      prepare_export
      create_file
      process_export
    end

    private

    def prepare_export
      validate_args_presence
      validate_args_value
    end

    def create_file
      name_sheet
      set_data
      validate_data
      fill_messages
      fill_header
      fill_file
    end

    def process_export
      style_file
      log_state
      save_file
    end

    alias_method :base_create_file, :create_file

  end
end