
# require "eitil_integrate/application_exporter/selectors"

require "eitil_integrate/application_exporter/initialize"

module EitilIntegrate::RubyXL
  class ApplicationExporter

    private

    # rows

    def current_row
      x
    end

    def previous_row
      x - 1
    end

    def next_row
      x + 1
    end

    def first_row
      0
    end

    # columns

    def current_column
      y
    end

    def previous_column
      y - 1
    end

    def next_column
      y + 1
    end

    def first_column
      0
    end

    # RubyXL object selectors for rows. For columns I have not found a RubyXL object, 
    # or a practical way of accessing the cells of a column, yet.

    def method_missing(_method, *args, &block)     
      m = _method.to_s
      super _method unless m.include?('row') and m.ends_with?('_object')
      super _method unless respond_to? m.delete_suffix!('_object'), true
      sheet[send(m)]
    end

  end
end