
# require "eitil_integrate/application_exporter/setters"

require "eitil_integrate/application_exporter/initialize"

module EitilIntegrate::RubyXL
  class ApplicationExporter

    # The date setter methods allow Exporters to receive dates as strings, which are
    # required to prevent serialization errors in perform_later background jobs.

    private

    def set_start_date
      @start_date.is_a?(Date) ? @start_date : Date.parse(@start_date) if @start_date
    end

    def set_end_date
      @end_date.is_a?(Date) ? @end_date : Date.parse(@end_date) if @end_date
    end

    def set_date_range
      @start_date..@end_date if @start_date && @end_date
    end
    
  end
end