
# require "eitil_integrate/application_exporter/store_file"

require "eitil_integrate/application_exporter/initialize"
require "eitil_core/setters/set_ivars"

module EitilIntegrate::RubyXL
  class ApplicationExporter
    
    attr_accessor :storage_path

    private

    def save_file
      set_ivars :storage_path
      save_book
      run_after_save_effects
      @storage_path
    end

    def set_storage_path
      "#{Rails.root}/data/#{self.class.name.snakecase}_#{DateTime.now.prettify}.xlsx"
    end

    def save_book
      book.write @storage_path
    end

    def run_after_save_effects
      # nil fallback for if the application class (which inherits from ApplicationExporter) has no method #run_after_save_effects
    end

  end
end