
# require "eitil_wrapper/request_logger/controller_mixin"

require_relative "logger_job"

module EitilWrapper
  module RequestLogger
    module ControllerMixin

      private

      def log_request
        $request_logger_path ||= "#{Rails.root}/log/request_logger.log"
        EitilWrapper::RequestLogger::LoggerJob.perform_later(request_logger_object)
      end
      
      def request_logger_object
        
        log_request = {
          path:       request.env["REQUEST_PATH"],
          method:     request.env["REQUEST_METHOD"],
          query_str:  request.env["QUERY_STRING"], 
        }
       
        log_params = {
          params:     params.as_json
        }

        log_attributes = {
          time:       Time.now.strftime("%Y-%m-%d %H:%M:%S")
        }

        log = {
          request:    log_request,
          params:     log_params,
          attributes: log_attributes
        }

        log_time = log_attributes[:time]
        log_strf = log.deep_symbolize_keys.to_s   
        # log_strf may be hashed through eval(log_strf)

        return log_strf
      end    
   
    end
  end
end